Wiki ЖБК

Материалы для проектирования железобетонных конструкций

Инструменты пользователя

Инструменты сайта


скрипт_3dface_плиты

Скрипт для преобразования прямоугольников в 3dface

Автор: Dmitry Rudenko

C помощью этого скрипта (VBA) можно подготовить в nanoCAD плиты для последующего импорта в препроцессоры расчётных программ. Скрипт преобразует прямоугольники (или замкнутые 4х-узловые полилинии) в 3dFace, которые воспринимаются препроцессором, как оболочки.

3dface-frm-poly.vbs
Dim ms
Set ms = ThisDrawing.ModelSpace
Dim ut
Set ut = ThisDrawing.Utility
 
ut.Prompt "Небольшой скрипт на VBA, который преобразует выбранные прямоугольники в 3dface"
 
Dim myObj, solid
dim pt0(2), pt1(2), pt2(2), pt3(2)
dim pptpl
 
Dim sSet, cnt
set sSet = ThisDrawing.ActiveSelectionSet
sSet.SelectOnScreen
cnt = sSet.Count
 
Dim i
for i=0 to cnt-1
	set myObj = sSet.Item(i)
	if (myObj.ObjectName = "AcDbPolyline") then
		pptpl = ut.CreateSafeArrayFromVector(myObj.Coordinates)
		pt0(0) = pptpl(0)
		pt0(1) = pptpl(1)
		pt0(2) = myObj.Elevation
		pt1(0) = pptpl(2)
		pt1(1) = pptpl(3)
		pt1(2) = myObj.Elevation
		pt2(0) = pptpl(4)
		pt2(1) = pptpl(5)
		pt2(2) = myObj.Elevation
		pt3(0) = pptpl(6)
		pt3(1) = pptpl(7)
		pt3(2) = myObj.Elevation
		set solid = ms.Add3dFace(pt0,pt1,pt2,pt3)
		solid.layer = myObj.layer
		myObj.delete
	end if
next
ut.Prompt "Готово, проверяй!"
sSet.Clear

Обсуждение

PashaStr, 2013-11-17 19:10
Спасибо за скрипт. Очень ценная и полезная вещь. Давно пытался хоть как-то автоматизировать перевод из dwg в скад моделей.
Dmitry Rudenko, 2013-11-17 21:46
На вики есть целая статья, посвященная подготовке расчётных моделей: http://fordewind.org/wiki/doku.php?id=%D0%BF%D0%BE%D0%B4%D0%B3%D0%BE%D1%82%D0%BE%D0%B2%D0%BA%D0%B0_%D0%B2_%D0%B0%D0%B2%D1%82%D0%BE%D0%BA%D0%B0%D0%B4%D0%B5
PashaStr, 2013-11-18 08:56
спасибо, уже посмотрел
VadimSpb, 2014-01-23 19:36
А есть ли решение для AutoCad именно для поли линий(на двг.ру только для линий нашел) ?
Dmitry Rudenko, 2014-01-23 19:50
Я не встречал.
VadimSpb, 2014-01-23 19:57
туплю есть же "область" , спасибо за быстрый ответ.
Дмитрий, 2014-10-20 11:32
http://cadtips.cadalyst.com/surfaces/convert-polylines-3d-face-objects
для ACad
Ваш комментарий:
   __  ___   _  __  _      __
  /  |/  /  / |/ / | | /| / /
 / /|_/ /  /    /  | |/ |/ / 
/_/  /_/  /_/|_/   |__/|__/
 
PDF Export Download this page as a pdf Text Export Download this page as a plain text
скрипт_3dface_плиты.txt · Последние изменения: 2013-11-17 18:44 — swell

Инструменты страницы